ON_Extrusion Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_beam.h>`

Inheritance diagram for ON_Extrusion:

## Public Member Functions

| ON_Extrusion ()
| ON_Extrusion (const ON_Extrusion &src)
| ~ON_Extrusion ()
ON_Extrusion & | operator= (const ON_Extrusion &)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | Write (ON_BinaryArchive &binary_archive) const
ON_BOOL32 | Read (ON_BinaryArchive &binary_archive)
ON::object_type | ObjectType () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *boxmin, double *boxmax, int bGrowBox=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &xform)
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
ON_Brep * | BrepForm (ON_Brep *brep, bool bSmoothFaces) const
ON_SumSurface * | SumSurfaceForm (ON_SumSurface *sum_surface) const
bool | GetBrepFormComponentIndex (ON_COMPONENT_INDEX extrusion_ci, ON_COMPONENT_INDEX &brep_ci) const
bool | GetBrepFormComponentIndex (ON_COMPONENT_INDEX extrusion_ci, double extrusion_profile_parameter, const ON_Brep &brep_form, ON_COMPONENT_INDEX &brep_ci) const
ON_BOOL32 | SetDomain (int dir, double t0, double t1)
ON_Interval | Domain (int dir) const
ON_BOOL32 | GetSurfaceSize (double *width, double *height) const
int | SpanCount (int dir) const
ON_BOOL32 | GetSpanVector (int dir, double *span_vector) const
ON_BOOL32 | GetSpanVectorIndex (int dir, double t, int side, int *span_vector_index, ON_Interval *span_interval) const
int | Degree (int dir) const
ON_BOOL32 | GetParameterTolerance (int dir, double t, double *tminus, double *tplus) const
ISO | IsIsoparametric (const ON_Curve &curve, const ON_Interval *curve_domain=NULL) const
ON_BOOL32 | IsPlanar (ON_Plane *plane=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (int) const
ON_BOOL32 | IsPeriodic (int) const
bool | GetNextDiscontinuity (int dir, ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double s, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ISO | IsIsoparametric (const ON_BoundingBox &bbox) const
ON_BOOL32 | Reverse (int dir)
ON_BOOL32 | Transpose ()
ON_BOOL32 | Evaluate (double u, double v, int num_der, int array_stride, double *der_array, int quadrant=0, int *hint=0) const
ON_Curve * | IsoCurve (int dir, double c) const
ON_BOOL32 | Trim (int dir, const ON_Interval &domain)
bool | Extend (int dir, const ON_Interval &domain)
ON_BOOL32 | Split (int dir, double c, ON_Surface *&west_or_south_side, ON_Surface *&east_or_north_side) const
bool | GetClosestPoint (const ON_3dPoint &P, double *s, double *t, double maximum_distance=0.0, const ON_Interval *sdomain=0, const ON_Interval *tdomain=0) const
ON_BOOL32 | GetLocalClosestPoint (const ON_3dPoint &, double, double, double *, double *, const ON_Interval *=NULL, const ON_Interval *=NULL) const
int | GetNurbForm (ON_NurbsSurface &nurbs_surface, double tolerance=0.0) const
int | HasNurbForm () const
bool | GetSurfaceParameterFromNurbFormParameter (double nurbs_s, double nurbs_t, double *surface_s, double *surface_t) const
bool | GetNurbFormParameterFromSurfaceParameter (double surface_s, double surface_t, double *nurbs_s, double *nurbs_t) const
void | Destroy ()
bool | SetPath (ON_3dPoint A, ON_3dPoint B)
bool | SetPathAndUp (ON_3dPoint A, ON_3dPoint B, ON_3dVector up)
int | PathParameter () const
ON_3dPoint | PathStart () const
ON_3dPoint | PathEnd () const
ON_3dVector | PathTangent () const
bool | SetMiterPlaneNormal (ON_3dVector N, int end)
void | GetMiterPlaneNormal (int end, ON_3dVector &N) const
int | IsMitered () const
bool | IsSolid () const
int | IsCapped () const
int | CapCount () const
ON_DEPRECATED int | FaceCount () const
bool | GetProfileTransformation (double s, ON_Xform &xform) const
bool | GetProfilePlane (double s, ON_Plane &plane) const
bool | GetPathPlane (double s, ON_Plane &plane) const
bool | SetOuterProfile (ON_Curve *outer_profile, bool bCap)
bool | AddInnerProfile (ON_Curve *inner_profile)
int | ProfileCount () const
int | ProfileSmoothSegmentCount (int profile_index) const
int | ProfileParameter () const
const ON_Curve * | Profile (int profile_index) const
ON_Curve * | Profile3d (int profile_index, double s) const
ON_Curve * | Profile3d (ON_COMPONENT_INDEX ci) const
ON_Curve * | WallEdge (ON_COMPONENT_INDEX ci) const
ON_Surface * | WallSurface (ON_COMPONENT_INDEX ci) const
ON_LineCurve * | PathLineCurve (ON_LineCurve *line_curve) const
int | ProfileIndex (double profile_parameter) const
const ON_PolyCurve * | PolyProfile () const
int | GetProfileCurves (ON_SimpleArray< const ON_Curve * > &profile_curves) const
int | GetProfileKinkParameters (int profile_index, ON_SimpleArray< double > &profile_kink_parameters) const
bool | ProfileIsKinked (int profile_index) const
Public Member Functions inherited from ON_Surface
void | DestroyRuntimeCache (bool bDelete=true)
| ON_Surface ()
| ON_Surface (const ON_Surface &)
ON_Surface & | operator= (const ON_Surface &)
virtual | ~ON_Surface ()
unsigned int | SizeOf () const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
virtual ON_Surface * | DuplicateSurface () const
ON::object_type | ObjectType () const
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
ON_BOOL32 | GetDomain (int dir, double *t0, double *t1) const
bool | SetDomain (int dir, ON_Interval domain)
bool | IsSphere (ON_Sphere *sphere=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCylinder (ON_Cylinder *cylinder=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCone (ON_Cone *cone=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsTorus (ON_Torus *torus=NULL, double tolerance=ON_ZERO_TOLERANCE) const
virtual ON_BOOL32 | IsSingular (int) const
bool | IsSolid () const
bool | IsAtSingularity (double s, double t, bool bExact=true) const
int | IsAtSeam (double s, double t) const
ON_3dPoint | PointAt (double, double) const
ON_3dVector | NormalAt (double, double) const
ON_BOOL32 | FrameAt (double u, double v, ON_Plane &frame) const
ON_BOOL32 | EvPoint (double u, double v, ON_3dPoint &point, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &duu, ON_3dVector &duv, ON_3dVector &dvv, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &normal, int=0, int *=0) const
ON_NurbsSurface * | NurbsSurface (ON_NurbsSurface *pNurbsSurface=NULL, double tolerance=0.0, const ON_Interval *s_subdomain=NULL, const ON_Interval *t_subdomain=NULL) const
void | DestroySurfaceTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Static Public Member Functions

static bool | IsValidPolyCurveProfile (const ON_PolyCurve &polycurve, ON_TextLog *text_log=0)
static bool | CleanupPolyCurveProfile (ON_PolyCurve &polycurve)
static ON_Extrusion * | Cylinder (const ON_Cylinder &cylinder, bool bCapBottom, bool bCapTop, ON_Extrusion *extrusion=0)
static ON_Extrusion * | Pipe (const ON_Cylinder &cylinder, double other_radius, bool bCapBottom, bool bCapTop, ON_Extrusion *extrusion=0)
static ON_Extrusion * | CreateFrom3dCurve (const ON_Curve &curve, const ON_Plane *plane, double height, bool bCap, ON_Extrusion *extrusion=0)

## Public Attributes

ON_Line | m_path
ON_Interval | m_t
ON_3dVector | m_up
int | m_profile_count
ON_Curve * | m_profile
bool | m_bCap [2]
bool | m_bHaveN [2]
ON_3dVector | m_N [2]
ON_Interval | m_path_domain
bool | m_bTransposed

## Static Public Attributes

static const double | m_Nz_min
static const double | m_path_length_min

## Additional Inherited Members

Public Types inherited from ON_Surface
enum | ISO { not_iso = 0, x_iso = 1, y_iso = 2, W_iso = 3, S_iso = 4, E_iso = 5, N_iso = 6, iso_count = 7 }

## Detailed Description

Definition at line 36 of file opennurbs_beam.h.

## Constructor & Destructor Documentation

ON_Extrusion::ON_Extrusion | ( |  | ) |

ON_Extrusion::ON_Extrusion | ( | const ON_Extrusion & | src | ) |

ON_Extrusion::~ON_Extrusion | ( |  | ) |

## Member Function Documentation

bool ON_Extrusion::AddInnerProfile | ( | ON_Curve * | inner_profile | ) |

ON_Brep* ON_Extrusion::BrepForm | ( | ON_Brep * | brep = `NULL` | ) | const

virtual

Reimplemented from ON_Geometry.

ON_Brep* ON_Extrusion::BrepForm | ( | ON_Brep * | brep,
|  | bool | bSmoothFaces
| ) |  | const

int ON_Extrusion::CapCount | ( |  | ) | const

static bool ON_Extrusion::CleanupPolyCurveProfile | ( | ON_PolyCurve & | polycurve | ) |

static

static ON_Extrusion* ON_Extrusion::CreateFrom3dCurve | ( | const ON_Curve & | curve,
|  | const ON_Plane * | plane,
|  | double | height,
|  | bool | bCap,
|  | ON_Extrusion * | extrusion = `0`
| ) |  |

static

static ON_Extrusion* ON_Extrusion::Cylinder | ( | const ON_Cylinder & | cylinder,
|  | bool | bCapBottom,
|  | bool | bCapTop,
|  | ON_Extrusion * | extrusion = `0`
| ) |  |

static

ON__UINT32 ON_Extrusion::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

int ON_Extrusion::Degree | ( | int | dir | ) | const

virtual

Implements ON_Surface.

void ON_Extrusion::Destroy | ( |  | ) |

int ON_Extrusion::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

ON_Interval ON_Extrusion::Domain | ( | int | dir | ) | const

virtual

Implements ON_Surface.

void ON_Extrusion::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

ON_BOOL32 ON_Extrusion::Evaluate | ( | double | u,
|  | double | v,
|  | int | num_der,
|  | int | array_stride,
|  | double * | der_array,
|  | int | quadrant = `0`,
|  | int * | hint = `0`
| ) |  | const

virtual

Implements ON_Surface.

bool ON_Extrusion::Extend | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

virtual

Reimplemented from ON_Surface.

ON_DEPRECATED int ON_Extrusion::FaceCount | ( |  | ) | const

ON_BOOL32 ON_Extrusion::GetBBox | ( | double * | boxmin,
|  | double * | boxmax,
|  | int | bGrowBox = `false`
| ) |  | const

virtual

Implements ON_Geometry.

bool ON_Extrusion::GetBrepFormComponentIndex | ( | ON_COMPONENT_INDEX | extrusion_ci,
|  | ON_COMPONENT_INDEX & | brep_ci
| ) |  | const

bool ON_Extrusion::GetBrepFormComponentIndex | ( | ON_COMPONENT_INDEX | extrusion_ci,
|  | double | extrusion_profile_parameter,
|  | const ON_Brep & | brep_form,
|  | ON_COMPONENT_INDEX & | brep_ci
| ) |  | const

bool ON_Extrusion::GetClosestPoint | ( | const ON_3dPoint & | P,
|  | double * | s,
|  | double * | t,
|  | double | maximum_distance = `0.0`,
|  | const ON_Interval * | sdomain = `0`,
|  | const ON_Interval * | tdomain = `0`
| ) |  | const

ON_BOOL32 ON_Extrusion::GetLocalClosestPoint | ( | const ON_3dPoint & | ,
|  | double | ,
|  | double | ,
|  | double * | ,
|  | double * | ,
|  | const ON_Interval * | = `NULL`,
|  | const ON_Interval * | = `NULL`
| ) |  | const

void ON_Extrusion::GetMiterPlaneNormal | ( | int | end,
|  | ON_3dVector & | N
| ) |  | const

bool ON_Extrusion::GetNextDiscontinuity | ( | int | dir,
|  | ON::continuity | c,
|  | double | t0,
|  | double | t1,
|  | double * | t,
|  | int * | hint = `NULL`,
|  | int * | dtype = `NULL`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Surface.

int ON_Extrusion::GetNurbForm | ( | ON_NurbsSurface & | nurbs_surface,
|  | double | tolerance = `0.0`
| ) |  | const

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::GetNurbFormParameterFromSurfaceParameter | ( | double | surface_s,
|  | double | surface_t,
|  | double * | nurbs_s,
|  | double * | nurbs_t
| ) |  | const

virtual

Reimplemented from ON_Surface.

ON_BOOL32 ON_Extrusion::GetParameterTolerance | ( | int | dir,
|  | double | t,
|  | double * | tminus,
|  | double * | tplus
| ) |  | const

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::GetPathPlane | ( | double | s,
|  | ON_Plane & | plane
| ) |  | const

int ON_Extrusion::GetProfileCurves | ( | ON_SimpleArray< const ON_Curve * > & | profile_curves | ) | const

int ON_Extrusion::GetProfileKinkParameters | ( | int | profile_index,
|  | ON_SimpleArray< double > & | profile_kink_parameters
| ) |  | const

bool ON_Extrusion::GetProfilePlane | ( | double | s,
|  | ON_Plane & | plane
| ) |  | const

bool ON_Extrusion::GetProfileTransformation | ( | double | s,
|  | ON_Xform & | xform
| ) |  | const

ON_BOOL32 ON_Extrusion::GetSpanVector | ( | int | dir,
|  | double * | span_vector
| ) |  | const

virtual

Implements ON_Surface.

ON_BOOL32 ON_Extrusion::GetSpanVectorIndex | ( | int | dir,
|  | double | t,
|  | int | side,
|  | int * | span_vector_index,
|  | ON_Interval * | span_interval
| ) |  | const

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::GetSurfaceParameterFromNurbFormParameter | ( | double | nurbs_s,
|  | double | nurbs_t,
|  | double * | surface_s,
|  | double * | surface_t
| ) |  | const

virtual

Reimplemented from ON_Surface.

ON_BOOL32 ON_Extrusion::GetSurfaceSize | ( | double * | width,
|  | double * | height
| ) |  | const

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

int ON_Extrusion::HasNurbForm | ( |  | ) | const

virtual

Reimplemented from ON_Surface.

int ON_Extrusion::IsCapped | ( |  | ) | const

ON_BOOL32 ON_Extrusion::IsClosed | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::IsContinuous | ( | ON::continuity | c,
|  | double | s,
|  | double | t,
|  | int * | hint = `NULL`,
|  | double | point_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d1_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d2_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Surface.

ISO ON_Extrusion::IsIsoparametric | ( | const ON_Curve & | curve,
|  | const ON_Interval * | curve_domain = `NULL`
| ) |  | const

virtual

Reimplemented from ON_Surface.

ISO ON_Extrusion::IsIsoparametric | ( | const ON_BoundingBox & | bbox | ) | const

virtual

Reimplemented from ON_Surface.

int ON_Extrusion::IsMitered | ( |  | ) | const

ON_Curve* ON_Extrusion::IsoCurve | ( | int | dir,
|  | double | c
| ) |  | const

virtual

Reimplemented from ON_Surface.

ON_BOOL32 ON_Extrusion::IsPeriodic | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

ON_BOOL32 ON_Extrusion::IsPlanar | ( | ON_Plane * | plane = `NULL`,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::IsSolid | ( |  | ) | const

ON_BOOL32 ON_Extrusion::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

static bool ON_Extrusion::IsValidPolyCurveProfile | ( | const ON_PolyCurve & | polycurve,
|  | ON_TextLog * | text_log = `0`
| ) |  |

static

ON::object_type ON_Extrusion::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

ON_Extrusion& ON_Extrusion::operator= | ( | const ON_Extrusion & |  | ) |

ON_3dPoint ON_Extrusion::PathEnd | ( |  | ) | const

ON_LineCurve* ON_Extrusion::PathLineCurve | ( | ON_LineCurve * | line_curve | ) | const

int ON_Extrusion::PathParameter | ( |  | ) | const

ON_3dPoint ON_Extrusion::PathStart | ( |  | ) | const

ON_3dVector ON_Extrusion::PathTangent | ( |  | ) | const

static ON_Extrusion* ON_Extrusion::Pipe | ( | const ON_Cylinder & | cylinder,
|  | double | other_radius,
|  | bool | bCapBottom,
|  | bool | bCapTop,
|  | ON_Extrusion * | extrusion = `0`
| ) |  |

static

const ON_PolyCurve* ON_Extrusion::PolyProfile | ( |  | ) | const

const ON_Curve* ON_Extrusion::Profile | ( | int | profile_index | ) | const

ON_Curve* ON_Extrusion::Profile3d | ( | int | profile_index,
|  | double | s
| ) |  | const

ON_Curve* ON_Extrusion::Profile3d | ( | ON_COMPONENT_INDEX | ci | ) | const

int ON_Extrusion::ProfileCount | ( |  | ) | const

int ON_Extrusion::ProfileIndex | ( | double | profile_parameter | ) | const

bool ON_Extrusion::ProfileIsKinked | ( | int | profile_index | ) | const

int ON_Extrusion::ProfileParameter | ( |  | ) | const

int ON_Extrusion::ProfileSmoothSegmentCount | ( | int | profile_index | ) | const

ON_BOOL32 ON_Extrusion::Read | ( | ON_BinaryArchive & | binary_archive | ) |

virtual

Reimplemented from ON_Object.

ON_BOOL32 ON_Extrusion::Reverse | ( | int | dir | ) |

virtual

Implements ON_Surface.

ON_BOOL32 ON_Extrusion::SetDomain | ( | int | dir,
|  | double | t0,
|  | double | t1
| ) |  |

virtual

Reimplemented from ON_Surface.

bool ON_Extrusion::SetMiterPlaneNormal | ( | ON_3dVector | N,
|  | int | end
| ) |  |

bool ON_Extrusion::SetOuterProfile | ( | ON_Curve * | outer_profile,
|  | bool | bCap
| ) |  |

bool ON_Extrusion::SetPath | ( | ON_3dPoint | A,
|  | ON_3dPoint | B
| ) |  |

bool ON_Extrusion::SetPathAndUp | ( | ON_3dPoint | A,
|  | ON_3dPoint | B,
|  | ON_3dVector | up
| ) |  |

unsigned int ON_Extrusion::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

int ON_Extrusion::SpanCount | ( | int | dir | ) | const

virtual

Implements ON_Surface.

ON_BOOL32 ON_Extrusion::Split | ( | int | dir,
|  | double | c,
|  | ON_Surface *& | west_or_south_side,
|  | ON_Surface *& | east_or_north_side
| ) |  | const

virtual

Reimplemented from ON_Surface.

ON_SumSurface* ON_Extrusion::SumSurfaceForm | ( | ON_SumSurface * | sum_surface | ) | const

ON_BOOL32 ON_Extrusion::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented from ON_Geometry.

ON_BOOL32 ON_Extrusion::Transpose | ( |  | ) |

virtual

Implements ON_Surface.

ON_BOOL32 ON_Extrusion::Trim | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

virtual

Reimplemented from ON_Surface.

ON_Curve* ON_Extrusion::WallEdge | ( | ON_COMPONENT_INDEX | ci | ) | const

ON_Surface* ON_Extrusion::WallSurface | ( | ON_COMPONENT_INDEX | ci | ) | const

ON_BOOL32 ON_Extrusion::Write | ( | ON_BinaryArchive & | binary_archive | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

bool ON_Extrusion::m_bCap[2]

Definition at line 768 of file opennurbs_beam.h.

bool ON_Extrusion::m_bHaveN[2]

Definition at line 778 of file opennurbs_beam.h.

bool ON_Extrusion::m_bTransposed

Definition at line 783 of file opennurbs_beam.h.

ON_3dVector ON_Extrusion::m_N[2]

Definition at line 779 of file opennurbs_beam.h.

const double ON_Extrusion::m_Nz_min

static

Definition at line 787 of file opennurbs_beam.h.

ON_Line ON_Extrusion::m_path

Definition at line 741 of file opennurbs_beam.h.

ON_Interval ON_Extrusion::m_path_domain

Definition at line 782 of file opennurbs_beam.h.

const double ON_Extrusion::m_path_length_min

static

Definition at line 791 of file opennurbs_beam.h.

ON_Curve* ON_Extrusion::m_profile

Definition at line 763 of file opennurbs_beam.h.

int ON_Extrusion::m_profile_count

Definition at line 762 of file opennurbs_beam.h.

ON_Interval ON_Extrusion::m_t

Definition at line 742 of file opennurbs_beam.h.

ON_3dVector ON_Extrusion::m_up

Definition at line 743 of file opennurbs_beam.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_beam.h